﻿package code
{
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import fl.controls.RadioButtonGroup;
    import fl.controls.RadioButton;
	import fl.controls.CheckBox;
    import fl.controls.Label;
	
	public class CalcOption extends Sprite
	{
		public var calcExo:CalcExo;
		public var typeOption:String;
		public var saisie:CalcTextField;
		public var radioGroup:RadioButtonGroup;
		public var aControle:Array;
		public var texte:String;
		public var largeur:Number;
		public var aLabel:Array;
		public var aValeur:Array;
		public var nom:String;
		public var selectedValue;
		public var disposition:String;
		public var etiquette:CalcTextField;
		public var tf:CalcTextFormat;
		public var commentaire:String;
		public var tfCommentaire:CalcTextField;
		private var curX:Number;
		private var curY:Number;
		private var orX:Number;
		
		
		public function CalcOption(nomOption,exo)
		{
			calcExo=exo;
			nom = nomOption;
			etiquette=new CalcTextField();
			etiquette.multiline=false;
			etiquette.wordWrap=false;
			etiquette.height = 21;
			largeur=20;
			
			tf = new CalcTextFormat();
			tf.size = 16; 
			//
			this.addEventListener(Event.ADDED_TO_STAGE,dessinerOption);
		}
		
		function dessinerOption(evt:Event)
		{
			calcExo.aCtrlOption.push(evt.target);
			etiquette.text = texte;
			this.addChild(etiquette);
			if (typeOption == "input")
			{
				saisie = new CalcTextField();
				saisie.multiline=false;
				saisie.wordWrap=false;
				saisie.type="input";
				saisie.textFormat.align = "center";
				saisie.defaultTextFormat = saisie.textFormat;
				saisie.width=largeur;
				saisie.autoSize="none";
				saisie.border=true;
				saisie.background = true;
				saisie.borderColor = 0xcccccc;
				saisie.backgroundColor = 0xffffff;
				saisie.text = calcExo.options[nom];
				addChild(saisie);
				saisie.x = etiquette.width + 10;
				if(commentaire != null)
				{
					tfCommentaire = new CalcTextField();
					tfCommentaire.multiline = false;
					tfCommentaire.wordWrap = false;
					tfCommentaire.textFormat.size = 12;
					tfCommentaire.textFormat.align = "center";
					tfCommentaire.defaultTextFormat = tfCommentaire.textFormat;
					tfCommentaire.text = commentaire;
					tfCommentaire.x = saisie.x + saisie.width+20;
					var largeurCommentaire = tfCommentaire.width;
					if(tfCommentaire.x + tfCommentaire.width + this.x > 725)
					{
						tfCommentaire.multiline = true;
						tfCommentaire.wordWrap = true;
						tfCommentaire.autoSize = "center";
						tfCommentaire.width = (735 - tfCommentaire.x - 20 - this.x);
					}
					addChild(tfCommentaire);
				}
			}
			else if (typeOption == "radio")
			{
				radioGroup = new RadioButtonGroup(nom);
				aControle = new Array()

				curX = etiquette.width + 10;
				curY = etiquette.y;
				orX = curX;
				
				for (var i=0; i < aLabel.length ; i++)
				{
					var rb:RadioButton = new RadioButton();
					if(aValeur[i] == calcExo.options[nom])
					{
						rb.selected = true;
						selectedValue=aValeur[i];
					}
					aControle.push(rb);
					rb.addEventListener(MouseEvent.CLICK,gestionControleClick)
					rb.setStyle("textFormat", tf);
					rb.name="radio"+i;
					rb.group = radioGroup;
					rb.label = aLabel[i];
					
					rb.textField.defaultTextFormat=tf;
					rb.textField.text=aLabel[i];
					rb.textField.autoSize="left";
					addChild(rb);
					//
					if(curX + rb.textField.width + 40 < 735 - 2*this.x)
					{
						rb.move(curX,curY);
						curX += rb.textField.width + 40;
					}
					else
					{
						curX = orX;
						curY += 30;
						rb.move(curX,curY);
						curX += rb.textField.width + 40;
					}
					
				}
			}
			else if (typeOption == "checkbox")
			{
				aControle = new Array();
				selectedValue = new Array();
				curX = etiquette.width + 10;
				curY = etiquette.y;
				orX = curX;
				
				for (var j=0; j < aLabel.length ; j++)
				{
					var cb:CheckBox = new CheckBox();
					if(calcExo.options[nom].indexOf(aValeur[j]) > -1)
					{
						cb.selected=true;
						selectedValue.push(aValeur[j]);
					}
					aControle.push(cb);
					cb.addEventListener(MouseEvent.CLICK,gestionControleClick)
					cb.setStyle("textFormat", tf);
					cb.name="checkbox"+j;
					cb.label = aLabel[j];
					
					cb.textField.defaultTextFormat=tf;
					cb.textField.text=aLabel[j];
					cb.textField.autoSize="left";
					addChild(cb);
					//
					if(curX + cb.textField.width + 40 < 735 - 2*this.x)
					{
						cb.move(curX,curY);
						curX += cb.textField.width + 40;
					}
					else
					{
						curX = orX;
						curY += 30;
						cb.move(curX,curY);
						curX += cb.textField.width + 40;
					}
				}
			}
		}
		
		public function gestionControleClick(evt:MouseEvent)
		{
			
			if (typeOption == "radio" )
			{
				var nIndex=aControle.indexOf(evt.target);
				selectedValue = aValeur[nIndex];
			} 
			else if (typeOption == "checkbox" )
			{
				selectedValue = new Array();
				for (var i=0;i<aControle.length;i++)
				{
					if (aControle[i].selected)
					{
						selectedValue.push(aValeur[i]);
					}
				}
			}
			
		}
		
		public function getCtrlOptionValue()
		{
			if (typeOption == "input" )
			{
				return saisie.text;
			}
			else 
			{
				return selectedValue;
			}
		}
	}
}