﻿/***********************************************************************************************************************************
Action Script 3.0 class
@ Description : Une classe pour generer des nombres aleatoires compris dans une plage
@ param : nTotal : nombre total de nombres a generer
@ param : nRangeMax : Entier borne superieure de la plage
@ param : nRangeMin : Entier borne inferieure (valeur par defaut 0 )
@ param : bRepeat : Booleen si faux les nombres sont tous distincts (vrai par defaut)
@ param : nMultipleOf : Entier les nombres generes sont multiples de ce nombre
@ param : bMultipleOf : Booleen if true no should be Multiple and false if Number should not be multiple of nMultipleOf
@ return : function genrate returns array of random Numbers
@ example to be written in fla
@**********************************************************************
@    import RandomNumber;
@    var nNumber:RandomNumber = new RandomNumber();
@    nA = nNumber.generate(3,20,10,false,4,false);
@    //Above line means that you need 3 random number from 10 to 20 should be non repeated and should not be divisible of 4
@**********************************************************************
@ Last modified:    12/10/2005
@ Flash version:    7.0
@ Author        Ajay Pal Singh
@ Version        1.0.1
**********************************************************************************************************************************/
package code 
{
class RandomNumber {
	private var nTotal:Number;
	private var nRangeMax:Number;
	private var nRangeMin:Number;
	private var nRange:Number;
	private var bRepeat:Boolean;
	private var nMultipleOf:Number;
	private var bMultipleOf:Boolean;
	function RandomNumber(nTotalEx:Number, nRangeMaxEx:Number, nRangeMinEx:Number=0, bRepeatEx:Boolean=true, nMultipleOfEx:Number=1, bMultipleOfEx:Boolean=true) {
		nTotal = nTotalEx;
		nRangeMax = nRangeMaxEx;
		nRangeMin = nRangeMinEx;
		//If undefined set to 0
		bRepeat = bRepeatEx;
		//If undefined set to true
		nMultipleOf = nMultipleOfEx;
		//If undefined set to 1
		bMultipleOf = bMultipleOfEx;
		//If undefined set to true
		nRange = nRangeMax-nRangeMin;
		if(nRange<nTotal-1){
			//au cas où la fourchette n'est pas suffisante 
			//on autorise les doublons
			bRepeat=true;
			trace("Range = "+nRange+" It's less than total of nbrs to be genrated");
		}
		
	}
	public function generate():Array {
		var n:Number;
		//n m & i are used as loop counters only
		var m:Number;
		var i:Number;
		var nX:Number;
		var aNx:Array = new Array();
		for (n=0; n<nTotal; n++) {
			nX = Math.round(Math.random()*nRange)+nRangeMin;
			aNx[n] = nX;
			if (!bRepeat) {
				for (m=0; m<n; m++) {
					if (aNx[n] == aNx[m]) {
						n--;
					}
				}
			}
			if (bMultipleOf) {
				if (aNx[n]%nMultipleOf != 0) {
					n--;
				}
			} 
			/*else {
				if ((aNx[n]%nMultipleOf) != 0) {
					n--;
				}
			}*/
		}
		return aNx;
	}
	/**public function clear() {
		nRange = (nRange == undefined) ? 0 : nRange;
		for (var i = 0; i<nRange; i++) {
			aNx.pop[nRange-i];
		}
	}**/
}
}